## Fast Array Clone Library

This library can x100 times faster make deep copies of an array or objects with similar structure in JavaScript

### EXAMPLE
    var sourceArray = [{ f1 : ..., f2: ... }, ...]; // array of SAME STRUCTURED object

#### Uses built-in array clone function
    var clonedArray = FastClone.cloneArray(sourceArray);

#### Uses object clone constructor factory
    var Clone = FastClone.factory(sourceArray[0]); // creating deep clone constructor function
    var clonedArray = sourceArray.map(function(item) {
        // you can add here custom logic
        return new Clone(item);
    });

### INSTALLATION
In a browser:
```html
<script src="https://cdn.rawgit.com/ivolovikov/fastest-clone/master/index.js"></script>
```
Using npm:
```
npm install fastest-clone
```


### LICENSE

Copyright (c) 2016 Ivan Volovikov

Licensed under the MIT license: http://www.opensource.org/licenses/mit-license.php

