'use strict';

//var profiler = require('v8-profiler');
//var _ = require('lodash');

const FastClone = require('.');


const source = {
    a: 1,
    b: 2,
    c: 3,
    d: 4,
    e: 5,
    f: 6,
    g: 7,
    h: 8,
    l: {
        a: 1,
        b: 2,
        c: 3,
        d: 4,
        e: 5,
        f: 6,
        g: 7,
        h: 8,
        m: [
            {d: 4,
        e: 5,
        f: 6,
        g: 7}
        ]
    }
};

//profiler.startProfiling('1', true);

console.time('fasclone');
const fn = FastClone.factory(source);
let c1;
for (var i = 0; i < 1000000; i++) {
    c1 = new fn(source);
    if (c1.a == -1) {
        throw Error();
    }
    c1.a = -1;
}
if (!c1) throw Error();  //  to prevent V8 optimization
console.timeEnd('fasclone');


/*console.time('fasclone2');
function clone(obj) {
    this.a = obj.a;
    this.b = obj.b;
    this.c = obj.c;
    this.d = obj.d;
    this.e = obj.e;
    this.f = obj.f;
    this.g = obj.g;
    this.h = obj.h;
}
let c1;
for (var i = 0; i < 1000000; i++) {
    c1 = new clone(source);
    if (c1.a == -1) {
        throw Error();
    }
    c1.a = -1;
}
if (!c1) throw Error();  //  to prevent V8 optimization
console.timeEnd('fasclone2');*/


/*var profile = profiler.stopProfiling('1');
profile.export(function(error, result) {
  fs.writeFileSync('profile1.cpuprofile', result);
  profile.delete();
});*/


//profiler.startProfiling('2', true);

/*console.time('native');
const keys = Object.keys(source);
//const keysL = Object.keys(source.l);
let c2;
for (var i = 0; i < 1000000; i++) {
    c2 = {};
    for (var j = 0; j < keys.length; j++) {
        const key = keys[j];
        /!*if (key == 'l') {
            c2[key] = {};
            for (var k = 0; k < keysL.length; k++) {
                c2[key][keysL[k]] = source[key][keysL[k]];
            }
        } else {*!/
            c2[key] = source[key];
        //}
    }
    if (c2.a == -1) {
        throw Error();
    }
    c2.a = -1;
}
if (!c2) throw Error();  //  to prevent V8 optimization
console.timeEnd('native');*/

/*
var profile = profiler.stopProfiling('2');
profile.export(function(error, result) {
  fs.writeFileSync('profile2.cpuprofile', result);
  profile.delete();
});
*/

/*console.time('lodash');
let c2;
for (var i = 0; i < 100000; i++) {
    c2 = _.cloneDeep(source);
    if (c2.a == -1) {
        throw Error();
    }
    c2.a = -1;
}
if (!c2) throw Error();  //  to prevent V8 optimization
console.timeEnd('lodash');*/


//const kkk = Object.keys(source);

/*console.time('fasclone-read');
let r = '';
for (let i = 0; i < c1.length; i++) {
    const obj1 = c1[i];
    const k = Math.random() * 7 | 0;
    r = r > obj1[kkk[k]] ? r : obj1[kkk[k]];
}
console.log(r);
console.timeEnd('fasclone-read');*/

/*console.time('native-read');
let r2 = '';
for (let i = 0; i < c2.length; i++) {
    const obj2 = c2[i];
    const k = Math.random() * 7 | 0;
    r2 = r2 > obj2[kkk[k]] ? r2 : obj2[kkk[k]];
}
console.log(r2);
console.timeEnd('native-read');*/
