'use strict';

var profiler = require('v8-profiler');
var fs = require('fs');

const FastClone = require('.');

const source = [];

for (var i = 0; i < 100000; i++) {
    source.push({
        a: 1,
        b: 2,
        c: 3,
        d: 4,
        e: 5,
        f: 6,
        g: 7,
        h: 8
    });
}

//profiler.startProfiling('1', true);

console.time('fasclone');
const fn = FastClone.factory(source);
const c1 = fn(source);
if (!c1) throw Error();  //  to prevent V8 optimization
console.log(c1[9999].a);

console.timeEnd('fasclone');

/*var profile = profiler.stopProfiling('1');
profile.export(function(error, result) {
  fs.writeFileSync('profile1.cpuprofile', result);
  profile.delete();
});*/


//profiler.startProfiling('2', true);

//console.time('native');
//const keys = Object.keys(source[0]);
//const c2 = [];
//for (let i = 0; i < source.length; i++) {
//    const cObj = {};
//    for (var j = 0; j < keys.length; j++) {
//        const key = keys[j];
//        cObj[key] = source[i][key];
//    }
//    c2.push(cObj);
//}
//if (!c2) throw Error(); //  to prevent V8 optimization
//console.log(c2[9999].b);
//console.timeEnd('native');

/*
var profile = profiler.stopProfiling('2');
profile.export(function(error, result) {
  fs.writeFileSync('profile2.cpuprofile', result);
  profile.delete();
});
*/


const kkk = Object.keys(source[0]);

/*console.time('fasclone-read');
let r = '';
for (let i = 0; i < c1.length; i++) {
    const obj1 = c1[i];
    const k = Math.random() * 7 | 0;
    r = r > obj1[kkk[k]] ? r : obj1[kkk[k]];
}
console.log(r);
console.timeEnd('fasclone-read');*/

/*console.time('native-read');
let r2 = '';
for (let i = 0; i < c2.length; i++) {
    const obj2 = c2[i];
    const k = Math.random() * 7 | 0;
    r2 = r2 > obj2[kkk[k]] ? r2 : obj2[kkk[k]];
}
console.log(r2);
console.timeEnd('native-read');*/
